#include <intrinsics.h>
#include "stm32f10x.h"
int mcnt=0;

#define ON_LED1     GPIOC->BRR = GPIO_Pin_9
#define OFF_LED1    GPIOC->BSRR = GPIO_Pin_9
#define T_LED1      GPIOC->ODR ^= GPIO_Pin_9

#define ON_LED2     GPIOC->BRR = GPIO_Pin_8
#define OFF_LED2    GPIOC->BSRR = GPIO_Pin_8
#define T_LED2      GPIOC->ODR ^= GPIO_Pin_8

void delay_us(uint32_t nCount){
int i;
  for(; nCount != 0; nCount--){
    for(i=0;i<11;i++) asm(" NOP ");
  }
}
void delay_ms(uint32_t nCount){
  for(; nCount != 0; nCount--) delay_us(1000);
}
void Timer1IntrHandler (void){
    // Clear update interrupt bit
  TIM_ClearITPendingBit(TIM1,TIM_FLAG_Update);
    OFF_LED1;
    delay_us(10);
    ON_LED1;

//    TIM_ClearITPendingBit(TIM1,TIM_FLAG_Update);
}
void main(void){
GPIO_InitTypeDef GPIO_InitStructure;
NVIC_InitTypeDef NVIC_InitStructure;
TIM_TimeBaseInitTypeDef TIM1_TimeBaseInitStruct;
  /* Setup STM32 system (clock, PLL and Flash configuration) */
  SystemInit();
  // GPIO Init
  // Enable GPIO clock and release reset
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA |
                         RCC_APB2Periph_GPIOB |
                         RCC_APB2Periph_GPIOC,
                         ENABLE);
  RCC_APB2PeriphResetCmd(RCC_APB2Periph_GPIOA |
                         RCC_APB2Periph_GPIOB |
                         RCC_APB2Periph_GPIOC,
                         DISABLE);

  // Assign PC8, PC9 to LEDs
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_9;
  GPIO_Init(GPIOC, &GPIO_InitStructure);

  /* Set the Vector Table base location at 0x08000000 */
  NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);
  NVIC_PriorityGroupConfig(NVIC_PriorityGroup_4);

  // Timer1 Init
  // Enable Timer1 clock and release reset
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1,ENABLE);
  RCC_APB2PeriphResetCmd(RCC_APB2Periph_TIM1,DISABLE);
  // Set timer period 100 usec
  TIM1_TimeBaseInitStruct.TIM_Prescaler = 72;  // 1us resolution
  TIM1_TimeBaseInitStruct.TIM_CounterMode = TIM_CounterMode_Up;
  TIM1_TimeBaseInitStruct.TIM_Period = 100;  // 100 us
  TIM1_TimeBaseInitStruct.TIM_ClockDivision = TIM_CKD_DIV1;
  TIM1_TimeBaseInitStruct.TIM_RepetitionCounter = 0;
  TIM_TimeBaseInit(TIM1,&TIM1_TimeBaseInitStruct);
  // Clear update interrupt bit
  TIM_ClearITPendingBit(TIM1,TIM_FLAG_Update);
  // Enable update interrupt
  TIM_ITConfig(TIM1,TIM_FLAG_Update,ENABLE);

  NVIC_InitStructure.NVIC_IRQChannel = TIM1_UP_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 7;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);

  // Enable timer counting
  TIM_Cmd(TIM1,ENABLE);
  __enable_interrupt();
    while(1){
        mcnt++;
        T_LED2;
    }
}
